unit Nrep;
{Version 1.0}
{FreeWare, but Copyright  No$ $oft 2:4635/41.5}
{Adapted by "Johnt Win Service", 1998}
interface
uses
SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
Forms, Dialogs, StdCtrls, Buttons, RXSpin, Grids, DB, DBTables,StrUtils,
ExtCtrls,OEMUtils,VclUtils,DsgnIntf ;
    type
TNTRNotifyEvent = procedure(Var CanPrint: boolean) of object;
{  }
type
TFieldArrayProperty = class(TPropertyEditor)
public
procedure Edit;override;
function GetAttributes: TPropertyAttributes;override;
function GetValue: string; override;
procedure SetValue(const Value: string); override;
end;
type
 TNosTextRepoter = class(TComponent)
private
{ Private declarations }
FDataLink:TDataLink;
FFile:TextFile;
FFieldArray: TStrings;
FHeader:string;
FFooter:string;
FFileName:string;
PrtStr:string;
FPageLength: integer;
FPrintPitch: integer;
FCurrentLine:LongInt;
FOem:boolean;
FPsev:boolean;
FDate,
FDialog,
FAHD,
FPrintN,
FHeaderOnEachPage:Boolean;
FNWidth:integer;
FOnPrint:TNTRNotifyEvent;
HorL,VerL,Krest,TopK,BotK,LeftK,RightK,LeftTop,LeftBot,RightTop,RightBot:char;
     SFileName:string;
     FSamInExe: boolean;

function GetDataSource: TDataSource;
procedure SetDataSource(Value: TDataSource);
function GetName(i:integer):String;
function GetLabel(i:integer):String;
function GetType(i:integer):Char;
function GetWidth(i:integer):Byte;
function GetDec(i:integer):Byte;
function GetAlign(i:integer):Char;
function GetValueAsString(i:integer):string;
procedure SetGraphics;
procedure WriteLine(s:string);
procedure WriteHeader;
procedure WriteFooter;
{procedure WriteLastFooter;}
protected
{ Protected declarations }
public
{ Public declarations }
constructor Create(AOwner: TComponent); override;
destructor Destroy; override;
procedure Print;
function EditFieldSpecs:boolean;
published
{ Published declarations }
property DataSource: TDataSource read GetDataSource write SetDataSource;
property FieldSpecs: TStrings read FFieldArray write FFieldArray;
property Header: string read FHeader write FHeader;
property Footer: string read FFooter write FFooter;
property OutFileName: string read FFileName write FFileName;
property OEMConvert: boolean read FOem write FOem default true;
property UsePsevdoGraphics:boolean read FPsev write FPsev default true;
property PlaceDateTime: boolean read FDate write FDate default True;
property ShowSaveAsDialog: boolean read FDialog write FDialog default True;
property AddHiddenFields: boolean read FAHD write FAHD default False;
property PrintNColumn: boolean read FPrintN write FPrintN default True;
   property PrintPitch: integer read FPrintPitch write FPrintPitch;
property NColumnWidth: integer read FNWidth write FNWidth ;
property OnPrint:TNTRNotifyEvent read FOnPrint write FOnPrint;
property PageLength: integer read FPageLength write FPageLength;
property HeaderOnEachPage: boolean read FHeaderOnEachPage write FHeaderOnEachPage default True;
   property SamFileName: string read SFileName write SFileName;
   property SamInExe: boolean read FSamInExe write FSamInExe default true;
end;
type
 a = string[25];
 b = string[40];
 c = string[1];
 d = string[3];
 e = string[3];
 f = string[1];

ac = integer;
PlaceDateTime = boolean;
UsePsevdoGraphics = boolean;
ShowSaveAsDialog  = boolean;
PrintNColumn = boolean;
NColumnWidth = integer;
OEMConvert = boolean;
Header = string[255];
Footer = string[255];
PageLength = integer;
HeaderOnEachPage = boolean;
PrintPitch = integer;

    Rpt_Book = record
             AC: ac;
             a1: a;
             b1: b;
             c1: c;
             d1: d;
             e1: e;
             f1: f;
            pdt: PlaceDateTime;
            upg: UsePsevdoGraphics;
           ssad: ShowSaveAsDialog;
            pnc: PrintNColumn;
            ncw: NColumnWidth;
           oemc: OEMConvert;
              h: Header;
              f: Footer;
             pl: PageLength;
           hoep: HeaderOnEachPage;
             PP: PrintPitch;
                end;

TfmFieldSpecs = class(TForm)
ds: TDataSource;
cbFieldNames: TComboBox;
edLabel: TEdit;
SG: TStringGrid;
edWidth: TrxSpinEdit;
cbType: TComboBox;
cbAlign: TComboBox;
edDec: TrxSpinEdit;
btAdd: TBitBtn;
btOk: TBitBtn;
btRemove: TBitBtn;
btCancel: TBitBtn;
Label1: TLabel;
Label2: TLabel;
Label3: TLabel;
Label4: TLabel;
Label5: TLabel;
Label6: TLabel;
cbDate: TCheckBox;
cbPsev: TCheckBox;
cbFile: TCheckBox;
btAddAll: TBitBtn;
btInsert: TBitBtn;
lbTable: TLabel;
lbCount: TLabel;
Bevel1: TBevel;
btRemoveAll: TBitBtn;
cbPrintN: TCheckBox;
spWidth: TrxSpinEdit;
Label7: TLabel;
cbAnsi: TCheckBox;
edHeader: TEdit;
Label8: TLabel;
edFooter: TEdit;
Label9: TLabel;
Label10: TLabel;
cbHeaderOnEachPage: TCheckBox;
Bevel3: TBevel;
spPageLength: TrxSpinEdit;
    PrintRG1: TRadioGroup;
procedure btAddClick(Sender: TObject);
procedure btRemoveClick(Sender: TObject);
procedure FormCreate(Sender: TObject);
procedure cbFieldNamesChange(Sender: TObject);
procedure SGRowMoved(Sender: TObject; FromIndex, ToIndex: Longint);
procedure btAddAllClick(Sender: TObject);
procedure btInsertClick(Sender: TObject);
procedure SGSetEditText(Sender: TObject; ACol, ARow: Longint;
const Value: String);
procedure btRemoveAllClick(Sender: TObject);
procedure cbPrintNClick(Sender: TObject);
procedure SGKeyDown(Sender: TObject; var Key: Word;
Shift: TShiftState);
private
{ Private declarations }
public
AddInBottom:boolean;
function GetWidth:integer;
{ Public declarations }
end;
    procedure Register;
implementation
{$R *.DFM}
var
       RptFile: file of Rpt_Book;
       Work: Rpt_Book;
       Cray:integer;
{  }{Component Editor}
type
TNosTextRepoterEditor = class(TComponentEditor)
procedure ExecuteVerb(Index: Integer); override;
function GetVerb(Index: Integer): string; override;
function GetVerbCount: Integer; override;
end;
procedure TNosTextRepoterEditor.ExecuteVerb(Index: Integer);
begin
case index of
1: TNosTextRepoter(Component).Print;
0:begin
if (Component as TNosTextRepoter).DataSource =nil then begin
MessageDlg('   DataSource.', mtError, [mbOK], 0);
exit;
end;
if (Component as TNosTextRepoter).DataSource.DataSet =nil then begin
MessageDlg('DataSource.DataSet  .', mtError, [mbOK], 0);
exit;
end;
if not (Component as TNosTextRepoter).DataSource.DataSet.Active then begin
MessageDlg('DataSource.DataSet   .', mtError, [mbOK], 0);
exit;
end;
if (Component as TNosTextRepoter).EditFieldSpecs then
Designer.Modified;
end;
end;
end;
function TNosTextRepoterEditor.GetVerb(Index: Integer): string;
begin
case index of
0: Result := '&Edit FieldSpecs';
1: Result := '&Print...';
2: Result := '-';
3: Result := 'Adapted by JWS, 1998';
end;
end;
function TNosTextRepoterEditor.GetVerbCount: Integer;
begin
Result := 4;
end;
    {--------------------------------TFieldArrayProperty--------------------------------------}
procedure TFieldArrayProperty.Edit;
begin
if (GetComponent(0) as TNosTextRepoter).DataSource =nil then begin
MessageDlg('   DataSource.', mtError, [mbOK], 0);
exit;
end;
if (GetComponent(0) as TNosTextRepoter).DataSource.DataSet =nil then begin
MessageDlg('DataSource.DataSet  .', mtError, [mbOK], 0);
exit;
end;
if not (GetComponent(0) as TNosTextRepoter).DataSource.DataSet.Active then begin
MessageDlg('DataSource.DataSet   .', mtError, [mbOK], 0);
exit;
end;
if (GetComponent(0) as TNosTextRepoter).EditFieldSpecs then
SetValue('');
end;
procedure TFieldArrayProperty.SetValue(const Value: string);
begin
Modified;
end;
function TFieldArrayProperty.GetValue: string;
begin
if (GetComponent(0) as TNosTextRepoter).DataSource =nil then begin
Result:='(TFieldSpecs)';
exit;
end;
if (GetComponent(0) as TNosTextRepoter).DataSource.DataSet =nil then begin
Result:='(TFieldSpecs)';
exit;
end;
if not (GetComponent(0) as TNosTextRepoter).DataSource.DataSet.Active then begin
Result:='(TFieldSpecs)';
exit;
end;
Result:=IntToStr((GetComponent(0) as TNosTextRepoter).FFieldArray.Count)+':FieldsDef';
end;
function TFieldArrayProperty.GetAttributes: TPropertyAttributes;
begin
Result := [paDialog];
end;
{************************************ TNosTextRepoter **************************************}
constructor TNosTextRepoter.Create(AOwner: TComponent);
begin
inherited Create(AOwner);
FDataLink := TDataLink.Create;
FFieldArray:=TStringList.Create;
FPsev:=True;
FOem:=True;
FDate:=True;
FDialog:=True;
FAHd:=False;
FPrintN:=True;
FNWidth:=5;
FPageLength:=0;
FPrintPitch:=0;
FHeaderOnEachPage:=True;
FSamInExe:=True;
SFileName:='Report.dat';
SetGraphics;
end;
destructor TNosTextRepoter.Destroy;
begin
FDataLink.Free;
FDataLink := nil;
FFieldArray.Free;
inherited Destroy;
end;
function TNosTextRepoter.GetDataSource: TDataSource;
begin
Result := FDataLink.DataSource;
end;
procedure TNosTextRepoter.SetDataSource(Value: TDataSource);
begin
FDataLink.DataSource := Value;
end;
procedure TNosTextRepoter.WriteLine(s:string);
begin
if (FPageLength = 0) or (FCurrentLine < FPageLength) then begin
Writeln(FFile,s);
inc(FCurrentLine)
end else begin
WriteFooter;
Writeln(FFile,#12);
FCurrentLine:=1;
if FHeaderOnEachPage then WriteHeader;
end;
end;
procedure TNosTextRepoter.WriteHeader;
var i:integer;
begin
{----------------------   ---------------------------------}
PrtStr:='';

if FPrintN then PrtStr:=LeftTop+MakeStr(HorL,FNWidth)+TopK else PrtStr:=LeftTop;{ }
for i:=0 to FFieldArray.Count-2 do begin
PrtStr:=PrtStr+MakeStr(HorL,GetWidth(i)+2)+TopK;
end;

PrtStr:=PrtStr+MakeStr(HorL,GetWidth(FFieldArray.Count-1)+2)+RightTop;
Writeln(FFile,PrtStr);
if FPrintN then PrtStr:=Format(VerL+'%-'+IntToStr(FNWidth)+'s',['N'])+VerL else PrtStr:=VerL;{}
for i:=0 to FFieldArray.Count-1 do
if FOEM then  PrtStr:=PrtStr+' '+AddCharR(' ',Ansi2Oem(GetLabel(i)),GetWidth(i))+' '+VerL
else PrtStr:=PrtStr+' '+AddCharR(' ',GetLabel(i),GetWidth(i))+' '+VerL;
Writeln(FFile,PrtStr);
if FPrintN then PrtStr:=LeftK+MakeStr(HorL,FNwidth)+Krest else PrtStr:=LeftK;{ }
for i:=0 to FFieldArray.Count-2 do begin
PrtStr:=PrtStr+MakeStr(HorL,GetWidth(i)+2)+Krest;
end;
PrtStr:=PrtStr+MakeStr(HorL,GetWidth(FFieldArray.Count-1)+2)+RightK;
Writeln(FFile,PrtStr);
inc(FCurrentLine,3);
end;

procedure TNosTextRepoter.WriteFooter;
var i:integer;
begin
PrtStr:='';
if FPrintN then PrtStr:=LeftBot+MakeStr(HorL,FNWidth)+BotK else PrtStr:=LeftBot;{ }
for i:=0 to FFieldArray.Count-2 do begin
PrtStr:=PrtStr+MakeStr(HorL,GetWidth(i)+2)+BotK;
end;
PrtStr:=PrtStr+MakeStr(HorL,GetWidth(FFieldArray.Count-1)+2)+RightBot;
Writeln(FFile,PrtStr);
end;
{*********************       ********************}
procedure TNosTextRepoter.Print;
var F:TextFile;
SSS:String;
i,ww,mm:integer;
SD:TSaveDialog;
AllGood:boolean;
bmk:TBookMark;
CanPrint:boolean;
begin
{!!!}
IF (SamInExe <> True) then begin
AssignFile(RptFile, SFileName);
try
 Reset(Rptfile);
except
MessageDlg('   - '+SFileName, mtError, [mbOK], 0);
Exit;
end;

FFieldArray.Clear;
Read(RptFile, Work);
with Work do Cray:= AC;
for i:=1 to Cray do  { }
      begin
Read(RptFile, Work);
with Work do
FFieldArray.Add(Format('%-25s%-40s%1s%-3s%-3s%1s',
    [a1,b1,c1,d1,e1,f1]));
     end;

Read(RptFile, Work);
with Work do begin
PlaceDateTime:= pdt;
UsePsevdoGraphics:= upg;
ShowSaveAsDialog:= ssad;
PrintNColumn:= pnc;
NColumnWidth:= ncw;
OEMConvert:= oemc;
Header:= h;
Footer:= f;
PageLength:= pl;
HeaderOnEachPage:= hoep;
PrintPitch := pp;
end;
Close(RptFile);
    end;{if}

if FFieldArray.Count = 0 then begin
MessageDlg('      ', mtError, [mbOK], 0);
exit;
end;
{---------------------  DataSource-------------------------}
if DataSource =nil then begin
MessageDlg('   DataSource.', mtError, [mbOK], 0);
exit;
end;
if DataSource.DataSet =nil then begin
MessageDlg('DataSource.DataSet  .', mtError, [mbOK], 0);
exit;
end;
if not DataSource.DataSet.Active then begin
MessageDlg('DataSource.DataSet   .', mtError, [mbOK], 0);
exit;
end;
{------------------   --------------------------------------}
if (FDialog) or (length(FFileName)=0) then
with TSaveDialog.Create(Self) do begin
try
DefaultExt := 'txt';
Filter := 'i  DOS|*.txt|i |*.*';
Options := [ofOverwritePrompt];
FileName:=FFileName;
if Execute then
FFileName:=FileName
else begin
exit;
end;
finally
free;
end;
end;
{---------------------------------    --------------------------------}
try
StartWait;
{------------------------------- -----------------------------}
SetGraphics;
{---------------------------------  ---------------------------------}
AssignFile(FFile,FFileName);
try
Rewrite(FFile);
except
MessageDlg('    '+FFileName, mtError, [mbOK], 0);
Exit;
end;
{-------------------------------  -------------------------------}
FCurrentLine:=1;
{Header}

if (Length(FHeader) >= 0) then begin
if FPrintN then ww:=FNWidth else ww:=0;
for i:=0 to FFieldArray.Count-1 do ww:=ww+3+GetWidth(i);
PrtStr:=CenterStr(FHeader,ww+1);
case PrintPitch of
0: PrtStr:=Chr(27)+Chr(64)+PrtStr;
1: PrtStr:=Chr(27)+Chr(69)+Chr(27)+Chr(71)+PrtStr;
2: PrtStr:=Chr(27)+Chr(69)+PrtStr;
3: PrtStr:=Chr(15)+PrtStr;
  end;
if FOem then Writeline(Ansi2Oem(PrtStr))
else Writeline(PrtStr);
 end;
WriteHeader;
{----------------------------------  -------------------------------------}
try
with DataSource.DataSet do begin
DisableControls;
bmk:=GetBookMark;
First; mm:=1;
while not Eof do begin
PrtStr:=VerL+' ';
for i:=0 to FFieldArray.Count-1 do begin
if FOem then PrtStr:=PrtStr+Ansi2Oem(GetValueAsString(i))+' '+VerL+' '
else PrtStr:=PrtStr+GetValueAsString(i)+' '+VerL+' ';
end;
if FPrintN then begin
SSS:=Format(VerL+'%'+IntToStr(FNWidth)+'d',[mm]);
if Length(sss)>FNWidth+1 then SSS:=VerL+MakeStr('*',FNWidth);
PrtStr:=SSS+PrtStr;
end;
if Assigned(FOnPrint) then begin
CanPrint:=True;
OnPrint(CanPrint);
if CanPrint then begin WriteLine(PrtStr); inc(mm); end;
end else begin
WriteLine(PrtStr);
inc(mm);
end;
Next;
end;
GotoBookMark(bmk);
FreeBookMark(bmk);
end;
except
StopWait;
raise;
Flush(FFile);
CloseFile(FFile);
DataSource.DataSet.EnableControls;
DataSource.DataSet.FreeBookMark(bmk);
Exit;
end;
DataSource.DataSet.EnableControls;
{-----------------------------    ----------------------------}
WriteFooter;
if (Length(FFooter) >= 0) then begin {Footer}
PrtStr:=CenterStr(FFooter,ww+1);
PrtStr:=PrtStr+Chr(27)+Chr(64);
if FOem then Writeline(Ansi2Oem(PrtStr))
else Writeline(PrtStr);
end;
{  }
if FDate then Writeln(FFile,FormatDateTime('dd-mm-yyyy  hh:nn:ss',Now));
Flush(FFile);{ }
CloseFile(FFile);
{!!!}
Finally
StopWait;
end;
{
MessageDlg('i    '+FFileName, mtInformation, [mbOK], 0);
}
end;
        function TNosTextRepoter.GetName(i:integer):String;
begin
{   }
Result:=DelRSpace(copy(FFieldArray[i],1,25));
end;
function TNosTextRepoter.GetLabel(i:integer):String;
begin
{   }
Result:=Copy(DelRSpace(copy(FFieldArray[i],26,40)),1,GetWidth(i));
end;
function TNosTextRepoter.GetType(i:integer):Char;
begin
{   }
Result:= FFieldArray[i][66];
end;
function TNosTextRepoter.GetWidth(i:integer):Byte;
begin
{    }
Result:=StrToInt(DelRSpace(copy(FFieldArray[i],67,3)));
end;
function TNosTextRepoter.GetDec(i:integer):Byte;
begin
{ .     }
Result:=StrToInt(DelRSpace(copy(FFieldArray[i],70,3)));
end;
function TNosTextRepoter.GetAlign(i:integer):Char;
begin
{   }
Result:=FFieldArray[i][73];
end;
procedure TNosTextRepoter.SetGraphics;
begin
{ }
if FPsev then begin
HorL:=#196;VerL:=#179;Krest:=#197;TopK:=#194;
BotK:=#193;LeftK:=#195;RightK:=#180;LeftTop:=#218;
LeftBot:=#192;RightTop:=#191;RightBot:=#217;
end else begin
HorL:='-';VerL:='|';Krest:='+';TopK:='-';
BotK:='-';LeftK:='|';RightK:='|';LeftTop:='-';
LeftBot:='-';RightTop:='-';RightBot:='-';
end;
end;
function TNosTextRepoter.GetValueAsString(i:integer):string;
begin
{        }
case GetType(i) of
'S','D': if GetAlign(i) = 'L' then
Result:=Format('%-'+IntToStr(GetWidth(i))+'s',[DataSource.DataSet.FieldByName(GetName(i)).asString])
else
Result:=Format('%'+IntToStr(GetWidth(i))+'s',[DataSource.DataSet.FieldByName(GetName(i)).asString]);
'N': if GetAlign(i) = 'L' then
Result:=Format('%-'+IntToStr(GetWidth(i))+'.'+IntToStr(GetDec(i))+'f',
[DataSource.DataSet.FieldByName(GetName(i)).asFloat])
else
Result:=Format('%'+IntToStr(GetWidth(i))+'.'+IntToStr(GetDec(i))+'f',
[DataSource.DataSet.FieldByName(GetName(i)).asFloat]);
'G': if GetAlign(i) = 'L' then
Result:=Format('%-'+IntToStr(GetWidth(i))+'.'+IntToStr(GetDec(i))+'n',
[DataSource.DataSet.FieldByName(GetName(i)).asFloat])
else
Result:=Format('%'+IntToStr(GetWidth(i))+'.'+IntToStr(GetDec(i))+'n',
[DataSource.DataSet.FieldByName(GetName(i)).asFloat]);
'I': if GetAlign(i) = 'L' then
Result:=Format('%-'+IntToStr(GetWidth(i))+'d',[DataSource.DataSet.FieldByName(GetName(i)).asInteger])
else
Result:=Format('%'+IntToStr(GetWidth(i))+'d',[DataSource.DataSet.FieldByName(GetName(i)).asInteger]);
end;
if length(Result)>GetWidth(i) then
case GetType(i) of
'N','G','I': Result:=MakeStr('*',GetWidth(i));
'S','D':Result:=Copy(Result,1,GetWidth(i));
end;
end;

  function TNosTextRepoter.EditFieldSpecs;
var i:integer;
fmFieldSpecs: TfmFieldSpecs;

begin
Result:=False;
fmFieldSpecs:=TfmFieldSpecs.Create(Application);
with  fmFieldSpecs do begin
{    FSamInExe := True;
 AssignFile(Rptfile, 'ReporT.Dat');
 Reset(Rptfile);}

IF (SamInExe <> True) then begin
AssignFile(RptFile, SFileName);
try
 Reset(Rptfile);
 FFieldArray.Clear;
Read(RptFile, Work);
with Work do Cray:= AC;
for i:=1 to Cray do  { }
      begin
Read(RptFile, Work);
with Work do
FFieldArray.Add(Format('%-25s%-40s%1s%-3s%-3s%1s',
    [a1,b1,c1,d1,e1,f1]));
     end;

Read(RptFile, Work);
with Work do begin
PlaceDateTime:= pdt;
UsePsevdoGraphics:= upg;
ShowSaveAsDialog:= ssad;
PrintNColumn:= pnc;
NColumnWidth:= ncw;
OEMConvert:= oemc;
Header:= h;
Footer:= f;
PageLength:= pl;
HeaderOnEachPage:= hoep;
PrintPitch := pp;
end;

except
MessageDlg('   - '+SFileName+'.'#13#10+
' ³   .', mtError, [mbOK], 0);
{Exit;}
end;
    end;{if}


ds.DataSet:=DataSource.DataSet;
cbDate.Checked:=FDate;
cbPsev.Checked:=FPsev;
cbFile.Checked:=FDialog;
cbPrintN.Checked:=FPrintN;
spWidth.Value:=NColumnWidth;
cbAnsi.Checked:=FOEM;
edHeader.Text:=FHeader;
edFooter.Text:=FFooter;
spPageLength.Value:=PageLength;
cbHeaderOnEachPage.Checked:=HeaderOnEachPage;
PrintRG1.ItemIndex:=PrintPitch;

if cbPrintN.Checked then spWidth.Enabled:=True else spWidth.Enabled:=False;
for i:=0 to ds.DataSet.FieldCount-1 do
if FAHD then cbFieldNames.Items.Add(ds.DataSet.Fields[i].FieldName)
else if (ds.DataSet.Fields[i].Visible) then
cbFieldNames.Items.Add(ds.DataSet.Fields[i].FieldName);
if FFieldArray.Count > 0 then begin
{ }
SG.Cells[1,1]:=DelESpace(copy(FFieldArray[0],1,25));
SG.Cells[2,1]:=DelESpace(copy(FFieldArray[0],26,40));
SG.Cells[3,1]:=DelESpace(copy(FFieldArray[0],66,1));
SG.Cells[4,1]:=DelESpace(copy(FFieldArray[0],67,3));
SG.Cells[5,1]:=DelESpace(copy(FFieldArray[0],70,3));
SG.Cells[6,1]:=DelESpace(copy(FFieldArray[0],73,1));
for i:=1 to FFieldArray.Count-1 do begin
SG.RowCount:=SG.RowCount+1;
SG.Cells[1,i+1]:=DelESpace(copy(FFieldArray[i],1,25));
SG.Cells[2,i+1]:=DelESpace(copy(FFieldArray[i],26,40));
SG.Cells[3,i+1]:=DelESpace(copy(FFieldArray[i],66,1));
SG.Cells[4,i+1]:=DelESpace(copy(FFieldArray[i],67,3));
SG.Cells[5,i+1]:=DelESpace(copy(FFieldArray[i],70,3));
SG.Cells[6,i+1]:=DelESpace(copy(FFieldArray[i],73,1));
end;
for i:=1 to SG.RowCount-1 do SG.Cells[0,i]:=IntToStr(i);
end;
lbTable.Caption:=Format(' : %d',[ds.DataSet.RecordCount]);
GetWidth;
try
if  ShowModal = mrOk then begin {}
FFieldArray.Clear;
  IF (SamInExe <> True) then begin
  Rewrite(Rptfile);
With Work do begin
AC:=SG.RowCount-1;
Write(Rptfile, Work); end;  end;

for i:=1 to SG.RowCount-1 do
if SG.Cells[1,i] <> '' then  {   }
     begin
      IF (SamInExe <> True) then begin
{ small addition of JWS inside FILE!!!_}
with Work do         begin
a1 := SG.Cells[1,i];
b1 := SG.Cells[2,i];
c1 := SG.Cells[3,i];
d1 := SG.Cells[4,i];
e1 := SG.Cells[5,i];
f1 := SG.Cells[6,i];
Write(RptFile, Work); end;

                                 end else {inside EXE}
FFieldArray.Add(Format('%-25s%-40s%1s%-3s%-3s%1s',
[SG.Cells[1,i],SG.Cells[2,i],
SG.Cells[3,i],SG.Cells[4,i],
SG.Cells[5,i],SG.Cells[6,i] ]));
     end;

 IF (SamInExe <> True) then begin
with Work do  begin
  pdt:=cbDate.Checked;
  upg:=cbPsev.Checked;
 ssad:=cbFile.Checked;
  pnc:=cbPrintN.Checked;
  ncw:=round(spWidth.Value);
 oemc:=cbAnsi.Checked;
    h:=edHeader.Text;
    f:=edFooter.Text;
   pl:=round(spPageLength.Value);
 hoep:= cbHeaderOnEachPage.Checked;
   pp:= PrintRG1.ItemIndex;
 Write(RptFile, Work);
              end;

              end else begin
PlaceDateTime:=cbDate.Checked;
UsePsevdoGraphics:=cbPsev.Checked;
ShowSaveAsDialog:=cbFile.Checked;
PrintNColumn:=cbPrintN.Checked;
NColumnWidth:=round(spWidth.Value);
OEMConvert:=cbAnsi.Checked;
Header:=edHeader.Text;
Footer:=edFooter.Text;
PageLength:=round(spPageLength.Value);
HeaderOnEachPage:=cbHeaderOnEachPage.Checked;
PrintPitch:=PrintRG1.ItemIndex;
                        end;

Result:=True;
end;
 finally
 IF (SamInExe <> True) then CloseFile(RptFile);
 free;
 end;
end;
end;
{*********************************** TfmFieldSpecs *************************************}
function TfmFieldSpecs.GetWidth:integer;
var i:integer;
begin
try
Result:=0;
if SG.Cells[1,1]<>'' then
for i:=1 to SG.RowCount-1 do
Result:=Result+StrToInt(SG.Cells[4,i])+3;
lbCount.Caption:=Format(' : %d',[Result+1]);
except
;;
end;
end;
procedure TfmFieldSpecs.btAddClick(Sender: TObject);
var i:integer;
begin
{ }
if cbFieldNames.Text = '' then begin
MessageDlg('     ', mtError, [mbOK], 0);
exit;
end;
if edLabel.Text = '' then begin
MessageDlg('    ', mtError, [mbOK], 0);
exit;
end;
if cbType.Text = '' then begin
MessageDlg('  ', mtError, [mbOK], 0);
exit;
end;
if edWidth.Value =0  then begin
MessageDlg('    0', mtError, [mbOK], 0);
exit;
end;
if GetWidth+edWidth.Value+2 > 270 then begin
MessageDlg('    270 !', mtWarning, [mbOK], 0);
exit;
end;
{---------------      -------------------------}
for i:=1 to SG.RowCount-1 do
if SG.Cells[1,i]=cbFieldNames.Text then begin
if MessageDlg(' '+cbFieldNames.Text+'     !'#13'    ?',
mtConfirmation, [mbYes,mbNo], 0) <> mrYes
then exit else break;
end;
if not((SG.RowCount=2) and (SG.Cells[1,1]='')) then
SG.RowCount:=SG.RowCount+1; { }
if  AddInBottom then SG.Row:=SG.RowCount-1
else
for i:=SG.RowCount-1 downto SG.Row do begin {  }
SG.Cells[1,i]:=SG.Cells[1,i-1];
SG.Cells[2,i]:=SG.Cells[2,i-1];
SG.Cells[3,i]:=SG.Cells[3,i-1];
SG.Cells[4,i]:=SG.Cells[4,i-1];
SG.Cells[5,i]:=SG.Cells[5,i-1];
SG.Cells[6,i]:=SG.Cells[6,i-1];
end;
SG.Cells[1,SG.Row]:=cbFieldNames.Text;
SG.Cells[2,SG.Row]:=edLabel.Text;
SG.Cells[3,SG.Row]:=cbType.Text;
SG.Cells[4,SG.Row]:=IntToStr(round(edWidth.Value));
SG.Cells[5,SG.Row]:=IntToStr(round(edDec.Value));
SG.Cells[6,SG.Row]:=cbAlign.Text;
SG.Cells[0,SG.Row]:=IntToStr(SG.RowCount-1);
for i:=1 to SG.RowCount-1 do SG.Cells[0,i]:=IntToStr(i); {}
end;
procedure TfmFieldSpecs.btRemoveClick(Sender: TObject);
var i:integer;
begin
if (SG.RowCount > 2) then begin
for i:=SG.Row to SG.RowCount-2 do begin { }
SG.Cells[1,i]:=SG.Cells[1,i+1];
SG.Cells[2,i]:=SG.Cells[2,i+1];
SG.Cells[3,i]:=SG.Cells[3,i+1];
SG.Cells[4,i]:=SG.Cells[4,i+1];
SG.Cells[5,i]:=SG.Cells[5,i+1];
SG.Cells[6,i]:=SG.Cells[6,i+1];
end;
SG.RowCount:=SG.RowCount-1;
for i:=1 to SG.RowCount do SG.Cells[0,i]:=IntToStr(i)
end else begin
SG.Cells[1,1]:='';
SG.Cells[2,1]:='';
SG.Cells[3,1]:='';
SG.Cells[4,1]:='';
SG.Cells[5,1]:='';
SG.Cells[6,1]:='';
end;
GetWidth;
end;
procedure TfmFieldSpecs.FormCreate(Sender: TObject);
begin
SG.Cells[1,0]:=' ';
SG.Cells[2,0]:='';
SG.Cells[3,0]:='';
SG.Cells[4,0]:='';
SG.Cells[5,0]:='(,)';
SG.Cells[6,0]:='.';
AddInBottom:=False;
end;
procedure TfmFieldSpecs.cbFieldNamesChange(Sender: TObject);
begin
if Visible then begin
edLabel.Text:=ds.dataSet.FieldByName(cbFieldNames.Text).DisplayLabel;
case ds.dataSet.FieldByName(cbFieldNames.Text).Alignment of
taLeftJustify,taCenter:cbAlign.ItemIndex:=0;
taRightJustify:cbAlign.ItemIndex:=1;
end;
case (ds.dataSet.FieldByName(cbFieldNames.Text).DataType ) of
ftString:
begin
CbType.ItemIndex:=0;
edWidth.Value:=ds.dataSet.FieldByName(cbFieldNames.Text).Size;
end;
ftSmallint, ftInteger, ftWord:
begin
CbType.ItemIndex:=3;
edWidth.Value:=6;
end;
ftFloat,  ftBCD:
begin
CbType.ItemIndex:=1;
edWidth.Value:=19;
end;
ftCurrency:
begin
CbType.ItemIndex:=2;
edWidth.Value:=19;
end;
ftDate, ftTime, ftDateTime:
begin
CbType.ItemIndex:=4;
edWidth.Value:=10;
end;
end;
end;
end;
procedure TfmFieldSpecs.SGRowMoved(Sender: TObject; FromIndex, ToIndex: Longint);
var i:integer;
begin
for i:=1 to SG.RowCount do SG.Cells[0,i]:=IntToStr(i);
end;
procedure TfmFieldSpecs.btAddAllClick(Sender: TObject);
var i:integer;
begin
AddInBottom:=True;
for i:=0 to cbFieldNames.Items.Count -1 do begin
cbFieldNames.ItemIndex:=i;
cbFieldNamesChange(Self);
btAddClick(self);
end;
AddInBottom:=False;
GetWidth;
end;
procedure TfmFieldSpecs.btInsertClick(Sender: TObject);
begin
{   :
    btAdd
    btInsert}
AddInBottom:=True;
btAddClick(self);
AddInBottom:=False;
GetWidth;
end;
procedure TfmFieldSpecs.SGSetEditText(Sender: TObject; ACol, ARow: Longint;
const Value: String);
begin
if Acol = 4 then GetWidth;
end;
procedure TfmFieldSpecs.btRemoveAllClick(Sender: TObject);
begin
SG.RowCount:=2;
SG.Cells[1,1]:='';
SG.Cells[2,1]:='';
SG.Cells[3,1]:='';
SG.Cells[4,1]:='';
SG.Cells[5,1]:='';
SG.Cells[6,1]:='';
GetWidth;
end;
    procedure Register;
begin
RegisterComponents('Data Controls', [TNosTextRepoter]);
RegisterComponentEditor(TNosTextRepoter ,TNosTextRepoterEditor);
RegisterPropertyEditor(TypeInfo(TStrings), TNosTextRepoter, 'FieldSpecs', TFieldArrayProperty);
end;
procedure TfmFieldSpecs.cbPrintNClick(Sender: TObject);
begin
if cbPrintN.Checked then spWidth.Enabled:=True else spWidth.Enabled:=False;
end;
procedure TfmFieldSpecs.SGKeyDown(Sender: TObject; var Key: Word;
Shift: TShiftState);
begin
if (Key = VK_INSERT) then btAddClick(self);
if (Key = VK_Delete) and (Shift = [ssCtrl]) then btRemoveClick(self);
end;
end.
